/*
** Copyright R-U-ON, 2006
** www.r-u-on.com
*/

#include "ciao.h"
#include "iao_http.h"
#include "iao_comm.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <errno.h>

#include "cyassl/openssl/ssl.h"
#include "cyassl/openssl/rand.h"
#include "cyassl/openssl/err.h"
#include "cyassl/internal.h"


void iao_logsysmsg(char *msg)
{
	printf("%s\n", msg);
}

void iao_logmsg(char *msg)
{
	printf("%s\n", msg);
}

char * printsessionid( SSL_SESSION *session)
{	
	int i;
	static char buff[ID_LEN+1];

	for (i=0;i<ID_LEN;++i)
	{
		buff[i] = 'A'+session->sessionID[i]%('Z'-'A');
	}
	buff[ID_LEN] = 0;
	return buff;
}

int main(int argc, char *argv[])
{

	iao_tcpinit();

	iao_http_channel c;
	char *data;
	int i;
	static char lastsessionid[100]="";
	static int lasterror = 0;
		
	for (i=0;i<200000000;++i)
	{
		//time_t start = time(NULL);
		if (iao_geturl(&c, "https://localhost:8443/iaop1", &data)!=-1)
		{
			lasterror = 0;
			//printf("ct=\"%s\"\n", c.contenttype);
			////printf("%s\n", data);
			SSL_SESSION *sslsession = &(((SSL*)c.connection.ssl)->session);
			char *sid = printsessionid(sslsession);
			if (strcmp(lastsessionid, sid)!=0)
			{
				printf("%d %d %s\n", i, (int)time(NULL), sid);
				strcpy(lastsessionid, sid);
			}
			free(data);
		}
		else
		{
			if (lasterror==0)	
			{
				printf("error\n");
				lasterror = 1;
			}
		}
		//if (i%10==0) printf("%d\n", i);
		//printf("%d\n", (int)(time(NULL) - start));
		//scanf("%d", &i);
		//sleep(1);
		usleep(1000000);
	}

	return 0;
}
